/* Constantes et structures ... */
#define _GNU_SOURCE
#include <getopt.h>

#define Auteur "Olivier Delhomme"
#define Date "16 05 2003"
#define Licence "GPL"
#define Version "0.1.9 (31.05.2004)"
#define Version_Originelle "0.0.1 (16.05.2003)"
#define DEFLIGNES 1000
#define MAX_FILENAME 4096
#define MAX_HASH_SIZE 128
#define MAX_INT 2147483646
#define TAILLE_BUFFER 2048
#define MAXREP 1000

/* Configuration en dur ! A changer selon les besoins */
#define HASH_SETS_PATH "/divers/Hash_Sets/Connus/" 
#define MAX_INDIRECT 4 /* aucune indirection = 0 */
#define MALLOC_CHECK 2 /* Pour les erreurs de free et de malloc !! */

/* Autres constantes. */
#define TRUE 0
#define FALSE 1
#define ERREUR 3 
#define EXISTE 122

typedef struct
{
  int debug;      /* Pour debuggage                                     */
  int match;      /* Pour ceux qui sont ok                              */
  int reject;     /* Pour ceux qu'on ne trouve pas                      */
  int stat;       /* Pour faire des stats                               */
  int print;      /* Pour afficher \n ou \0                             */
  int unique;     /* Pour grer ou non les collisions dans les listes   */
  char aff;       /* un nombre pour dterminer les colonnes  afficher  */
  char *hash_sets_path;
} Options;


/* Une structure pour la lecture des fichiers */
typedef struct elt_ligne
{
  int ok;
  char *line;
  char *nom;
  char *hash;
} ligne;

static struct option const long_options[] =
{
  {"version", no_argument, NULL, 'v'},
  {"help",no_argument, NULL, 'h'},
  {"set", optional_argument, NULL, 's'},
  {"col", optional_argument, NULL, 'c'},
  {"stat", no_argument, NULL, 't'},
  {"print0", no_argument, NULL, '0'},
  {"match", no_argument, NULL, 'm'},
  {"reject", no_argument, NULL, 'r'},
  {"debug",no_argument, NULL, 'd'},
  {"unique",no_argument, NULL, 'u'},
  {NULL, 0, NULL, 0} 
};
