#define _GNU_SOURCE

#define LIB_Auteur "Olivier Delhomme"
#define LIB_Date "25 06 2003"
#define LIB_Licence "GPL"
#define LIB_Version "0.0.2 (31.05.2004)"
/* Version 0.0.2 31.05.2004
   - Normalisation C                      */

/* Constantes spcifiques */
/* Pour les erreurs de free et de malloc !! */
#define MALLOC_CHECK 2  

/* Autres constantes. */
#define TRUE 0
#define FALSE 1

/****************************************************************************/

/* trs mauvaise structure de recherche rapide : (linaire) */
/* pratique pour la gestion des collisions                  */
typedef struct elt_hash
{
  struct elt_hash *suivant; /* pointeur vers l'lment suivant           */
  char *nom_hash_set;       /* Le nom du fichier duquel est issu le hash */
  char *nom_fichier;        /* Le nom du fichier hach                   */
  char *hash;               /* Le hash en lui mme                       */
} l_hash;


/* Une structure de recherche un peu plus labore ... (16 indirections) */
typedef struct elt_rech
{
  struct elt_rech *ind[16];  /* Les pointeurs indirects vers des structures 
				identiques                                 */
  struct elt_hash *tab[16];  /* Les listes de hashs 
				(valides si ind[x]==NULL)                  */
} st_rech;

/* La structure pour garder des stats sur la structure st_rech :)          */
typedef struct elt_stat
{
  int nbdefichiers;
  int nbdelistes;
  int nbdelistesvides;
  int nbindirections;
  int longueurmin;
  int longueurmax;
} stat_st_rech;

/* Les prototypages :
   pour la structure l_hash  */
l_hash *cons_l_hash(l_hash *liste, char *nom_hash_set, char *nom_fichier, 
                    char *hash);
l_hash *free_l_hash(l_hash *liste);
l_hash *rech_l_hash(char *hash, l_hash *connue);
int longueur_l_hash(l_hash *liste);

/* Pour la structure st_rech */

st_rech *cons_st_rech(st_rech *sig, char *nom_hash_set, char *nom_fichier, 
		      char *hash, int niveau, int collision);
l_hash *rech_st_rech(st_rech *sig, l_hash *liste, int niveau);
void compute_stat_st_rech(stat_st_rech *s, st_rech *sig);
